import petsc4py, sys
petsc4py.init(sys.argv)
from petsc4py import PETSc

viewer = PETSc.Viewer().createBinary('mat.dat', 'r')
A = PETSc.Mat().load(viewer)
viewer = PETSc.Viewer().createBinary('rhs.dat', 'r')
b = PETSc.Vec().load(viewer)

ksp = PETSc.KSP().create(PETSc.COMM_WORLD)
ksp.setType('preonly')
pc = ksp.getPC()
pc.setType('lu')
pc.setFromOptions()

ksp.setOperators(A)
ksp.setFromOptions()
x = A.createVecRight()
ksp.solve(b, x)


# Plot
try:
    from dolfin import *
except ImportError:
    pass
else:
    mesh = UnitSquareMesh(32, 32)
    BDM = FiniteElement("BDM", mesh.ufl_cell(), 1)
    DG = FiniteElement("DG", mesh.ufl_cell(), 0)
    W = FunctionSpace(mesh, BDM * DG)
    w = Function(W)
    v = as_backend_type(w.vector()).vec()
    v += x
    v.assemble()
    as_backend_type(w.vector()).update_ghost_values()
    plot(w.sub(0))
    plot(w.sub(1))
    interactive()
